﻿//Mr.GearBuyer - Created by CodenameGamma - 12/26/11 - For WoW Version 4.0.3+
//Updated for Mist of Panderia WoW Version 5.0.4+ on 9/12/12
//Refactored and updated by RichieSams - For WoW Version 5.1+ on 12/10/12
//www.honorbuddy.com
//This is a free plugin, and should not be sold, or repackaged.
//Donations Accepted. 
//Version 2.7


using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Threading;
using System.Windows.Forms;
using MrGearBuyer.GUI;
using System;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System.IO;
using System.Xml.Linq;
using Styx.Plugins;
using Styx;
using Styx.CommonBot;
using Styx.Common.Helpers;
using Styx.CommonBot.POI;
using Styx.CommonBot.Profiles;
using Styx.CommonBot.Database;
using Styx.Common;
using Styx.CommonBot.Frames;

namespace MrGearBuyer
{
    public class MrGearBuyer : HBPlugin
    {
        #region Variables

        // For ease of typing
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        public bool WasInBG = false;
        private bool _initialized = false;

        // Settings variables
        public static bool LogoutAtHonorCap = true;
        public static bool LogoutAtJusticeCap = true;
        public static bool RemoveHPJPWhenCapped = true;

        // Holder for current item to buy
        private static ItemInfo itemToBuy = null;

        // List to hold what the user wants to buy
        public static BindingList<ItemInfo> wishList = new BindingList<ItemInfo>();

        // Default settings save path
        private static string SavePath
        {
            get { return string.Format("{0}\\Settings\\MrGearBuyerSettings_{1}.xml", AppDomain.CurrentDomain.BaseDirectory, StyxWoW.Me.Name); }
        }

        // Timer used to slow down how often this plugin updates
        private static WaitTimer _pulseTimer = new WaitTimer(TimeSpan.FromSeconds(4));

        #endregion // Variables

        #region Override of HBPlugin

        //Normal Stuff.
        public override string Name { get { return "Mr.GearBuyer"; } }
        public override string Author { get { return "CnG and RichieSams"; } }
        public override Version Version { get { return new Version(2, 7); } }
        public override bool WantButton { get { return true; } }
        public override string ButtonText { get { return "Mr.GearBuyer"; } }

        public override void Initialize()
        {
            if (_initialized)
                return;

            Vendors.OnBuyItems += BuyItems;

            // Loading item from settings file.
            LoadSettings();

            Slog("Mr.GearBuyer 2.7 Done Loading.");
            _initialized = true;
            WasInBG = false;
        }

        public override void OnButtonPress()
        {
            if (!_initialized)
            {
                Slog("Honorbuddy hasn't started yet. Initialize myself");
                Initialize();
            }

            new MGBConfig().ShowDialog();
        }

        public override void Pulse()
        {
            // Honorbuddy has a nasty habit of still moving when you port out of a bg
            // So test for when you enter/leave a battleground to send out a MoveStop()

            // Just entered a BG
            if (Battlegrounds.IsInsideBattleground && WasInBG == false)
            {
                WasInBG = true;
                Dlog("Entering a BG. Setting WasInBG = true");
            }
            // Just left a BG
            if (!Battlegrounds.IsInsideBattleground && WasInBG == true)
            {
                WasInBG = false;
                Dlog("Left a BG. Setting WasInBG = False");

                if (Me.IsMoving)
                {
                    Slog("Was still moving when coming back from a BG. Forced stop");
                    WoWMovement.MoveStop();
                }
            }

            // Only test the logic every 4 seconds instead of every pulse
            if (!_pulseTimer.IsFinished)
                return;

            // Reset the timer
            _pulseTimer.Reset();

            // Check that the user isn't in a BG/instance/raid
            if (Battlegrounds.IsInsideBattleground || Me.IsInInstance)
                return;

            // Don't override any POI set by the core
            if (BotPoi.Current.Type != PoiType.None)
                return;

            WoWCurrency currencyHp = WoWCurrency.GetCurrencyByType(WoWCurrencyType.HonorPoints);
            WoWCurrency currencyJp = WoWCurrency.GetCurrencyByType(WoWCurrencyType.JusticePoints);          

            // If user is at honor cap and has the checkbox set or if at justice point cap and has that checkbox set, force logout
            if (LogoutAtHonorCap && currencyHp.Amount == 4000 
                || LogoutAtJusticeCap && currencyJp.Amount == 4000)
            {
                Slog("HonorPoints and/or Justice Points are Capped! Logging out!");
                InactivityDetector.ForceLogout(true);
                return;
            }

            // Remove buying JP/HP if user is at the cap
            if (RemoveHPJPWhenCapped)
            {
                if (currencyHp.Amount == 4000)
                {
                    foreach (ItemInfo item in wishList)
                    {
                        if (item.ItemId == 392)
                        {
                            wishList.Remove(item);
                            SaveSettings();
                        }
                    }
                }
                if (currencyJp.Amount == 4000)
                {
                    foreach (ItemInfo item in wishList)
                    {
                        if (item.ItemId == 395)
                        {
                            wishList.Remove(item);
                            SaveSettings();
                        }
                    }
                }
            }

            // Get the first item on the wish list
            ItemInfo firstItem = wishList.FirstOrDefault();

            // WishList looks to be empty. Wait for user to populate the list
            if (firstItem == null)
                return;

            // Check if the user can afford it
            WoWCurrency currency = WoWCurrency.GetCurrencyByType(firstItem.ItemCostType);

            // Obviously if the user hasn't even discovered the currency yet, they can't afford it
            if (currency == null)
                return;

            // User has enough
            if (currency.Amount >= firstItem.ItemCost)
            {
                itemToBuy = firstItem;
            }


            // Removed the feature to try to get enough HP/JP by converting one into the other
            // The MoP HP/JP vendors are now miles away from each other, making trying to get from one to the other very difficult
            // Also, you can only exchange HP for JP or vice versa in the classic continents, but the MoP gear can only be bought in the MoP continent


            // We need to find the vendor
            WoWUnit vendorAsUnit = ObjectManager.GetObjectsOfType<WoWUnit>(false, false).FirstOrDefault(u => u.Entry == firstItem.ItemSupplierId);

            Vendor vendor;

            // Vendor isn't near the user. This won't do...
            if (vendorAsUnit == null)
            {
                // Check the database for the vendor as a second hope
                NpcResult npc = NpcQueries.GetNpcById(firstItem.ItemSupplierId);
                if (npc != null)
                {
                    vendor = new Vendor(npc.Entry, npc.Name, Vendor.VendorType.Unknown, npc.Location);
                }
                else
                {
                    Slog("Please move your toon near the vendor. Otherwise Mr.GearBuyer won't be able to buy items.");
                    return;
                }
            }
            else
            {
                vendor = new Vendor(vendorAsUnit, Vendor.VendorType.Unknown);
            }

            // We can't buy items if the vendor is blacklisted, so flush the blacklist if they are
            try
            {
                if (Blacklist.Contains(vendorAsUnit.Guid))
                {
                    Slog("For whatever reason vendor is blacklisted, Clearing Blacklist.");
                    Blacklist.Flush();
                }
            }
            catch (Exception ex)
            {
                Dlog(ex.StackTrace);
            }

            // Finish by setting the PoI
            BotPoi.Current = new BotPoi(vendor, PoiType.Buy);
        }

        #endregion // Override of HBPlugin

        private static void BuyItems(BuyItemsEventArgs args)
        {
            if (itemToBuy == null)
                return;

            MerchantItem itemMF = MerchantFrame.Instance.GetAllMerchantItems().FirstOrDefault(i => i.ItemId == itemToBuy.ItemId);

            if (itemMF == null)
            {
                // Try to find the item by name
                int numMerchantItems = Lua.GetReturnVal<int>("return GetMerchantNumItems()", 0);
                for (int i = 1; i <= numMerchantItems; i ++)
                {
                    String ItemName = Lua.GetReturnVal<String>("return GetMerchantItemInfo(" + i + ")", 0);

                    if (itemToBuy.ItemName == ItemName)
                    {
                        MrGearBuyer.Dlog("Found Vendor Item Match For {0} - Index: {1}", ItemName, i.ToString());
                        Lua.DoString("BuyMerchantItem(" + i + ")");
                        // Adding a sleep here to let WoW update itself with currencies. So we don't end up buying something wrong.
                        Thread.Sleep(1000);
                        _pulseTimer.Reset();
                        break;
                    }
                }

                Slog("This merchant doesn't sell {0}[{1}]. If it does, please inform the plugin writers and attach your log file.", itemToBuy.ItemName, itemToBuy.ItemId);
                return;
            }
            else
            {
                Lua.DoString("BuyMerchantItem(" + (itemMF.Index + 1) + ")");
                // Adding a sleep here to let WoW update itself with currencies. So we don't end up buying something wrong.
                Thread.Sleep(1000);
                _pulseTimer.Reset();
            }

            Slog("Bought item \"{0}\".", itemToBuy.ItemName);
            Slog("Removing {0} from WishList", itemToBuy.ItemName);
            wishList.Remove(itemToBuy);

            SaveSettings();

            itemToBuy = null;

            return;
        }



        // Logging class
        public static void Slog(string format, params object[] args)
        {
            Logging.Write("[Mr.GearBuyer]: " + format, args);
        }
        public static void Dlog(string format, params object[] args)
        {
            Logging.WriteDiagnostic("[Mr.GearBuyer-DEBUG]: " + format, args);
        }

        #region Settings

        private static void LoadSettings()
        {
            if (!File.Exists(SavePath))
                return;

            var xml = XElement.Load(SavePath);

            // Loading settings first.
            var settingsXml = xml.Element("Settings");

            if (settingsXml != null)
            {
                XElement element = settingsXml.Element("LogoutAtHonorCap");
                LogoutAtHonorCap = Convert.ToBoolean(element.Value);

                element = settingsXml.Element("LogoutAtJusticeCap");
                LogoutAtJusticeCap = Convert.ToBoolean(element.Value);

                element = settingsXml.Element("RemoveHPJPWhenCapped");
                RemoveHPJPWhenCapped = Convert.ToBoolean(element.Value);
            }

            var items = xml.Element("Items");

            if (items != null)
            {
                foreach (XElement element in items.Elements("Item"))
                {
                    wishList.Add(new ItemInfo(element));
                }
            }
        }

        public static void SaveSettings()
        {
            if (!Directory.Exists(Path.GetDirectoryName(SavePath)))
                Directory.CreateDirectory(Path.GetDirectoryName(SavePath));

            var xml = new XElement("MrGearBuyerConfig",
                            new XElement("Settings",
                                new XElement("LogoutAtHonorCap", LogoutAtHonorCap),
                                new XElement("LogoutAtJusticeCap", LogoutAtJusticeCap),
                                new XElement("RemoveHPJPWhenCapped", RemoveHPJPWhenCapped)
                                ),
                            new XElement("Items",
                                from i in wishList
                                select i.ToXml()));

            xml.Save(SavePath);
        }

        #endregion // Settings

    }

    

    // Class to help contain the info about an item
    public class ItemInfo
    {
        [Browsable(false)]
        public UInt32           ItemId { get; set;  }
        public String           ItemName { get; set; }
        public UInt32           ItemCost { get; set; }
        public WoWCurrencyType  ItemCostType { get; set; }
        [Browsable(false)]
        public UInt32           ItemSupplierId { get; set; }

        public ItemInfo()
        {}

        public ItemInfo(XElement xml)
        {
            ItemId = Convert.ToUInt32(xml.Element("ItemId").Value);
            ItemName = xml.Element("ItemName").Value;
            ItemCost = Convert.ToUInt32(xml.Element("ItemCost").Value);
            ItemCostType = (WoWCurrencyType)Enum.Parse(typeof(WoWCurrencyType), xml.Element("ItemCostType").Value, false);
            ItemSupplierId = Convert.ToUInt32(xml.Element("ItemSupplierId").Value);
        }

        public XElement ToXml()
        {
            return new XElement("Item",
                new XElement("ItemId", ItemId),
                new XElement("ItemName", ItemName),
                new XElement("ItemCost", ItemCost),
                new XElement("ItemCostType", ItemCostType),
                new XElement("ItemSupplierId", ItemSupplierId)
                );
        }

        public override string ToString()
        {
            return string.Format("ItemId:{0} ItemName:{1} ItemCost:{2} ItemCostType:{3} ItemSupplierId:{4}", ItemId, ItemName, ItemCost, ItemCostType, ItemSupplierId);
        }
    }
    

}